class iaas::profile::cinder (
  $password = undef,
  $public_interface = hiera('iaas::public_interface', undef),
  $admin_interface = hiera('iaas::admin_interface', undef),
  $secret = undef,
  $volume_size = undef,

#verbose, debug
  $verbose = hiera('iaas::verbose', undef),
  $debug = hiera('iaas::debug', undef),

  $region = hiera('iaas::region', undef),
  $endpoint = hiera('iaas::role::endpoint::main_address', undef),
#Added $rhosts
  $rhosts = hiera('iaas::profile::rabbitmq::rhosts', undef),
  $rabbitmq_user = hiera('iaas::profile::rabbitmq::user', undef),
  $rabbitmq_password = hiera('iaas::profile::rabbitmq::password', undef),
) {
  include iaas::resources::connectors
  iaas::resources::database { 'cinder': }

  class { '::cinder':
#Verbose, debug
    verbose => $verbose,
    debug => $debug,

    database_connection => $iaas::resources::connectors::cinder,
#Added rabbit_hosts
#    rabbit_host => $endpoint,
#    rpc_backend => 'rabbit',
    rabbit_hosts => $rhosts,
    rabbit_userid => $rabbitmq_user,
    rabbit_password => $rabbitmq_password,
    mysql_module => '2.3',
    database_idle_timeout => 3600,
  }

  class { '::cinder::glance':
    glance_api_servers => [ "${endpoint}:9292" ],
  }

  class { '::cinder::keystone::auth':
    password => $password,
    public_address => $endpoint,
    admin_address => $endpoint,
    internal_address => $endpoint,
    region => $region,
  }

  class { '::cinder::api':
#Identity_uri - planed to be implemented
    keystone_auth_host => $endpoint,
    keystone_password => $password,
    keystone_auth_uri => "http://${endpoint}:5000/v2.0",
#    keystone_identity_uri => "http://${endpoint}:35357",
    bind_host => $::facts["ipaddress_${admin_interface}"],
  }

  class { '::cinder::scheduler':
    scheduler_driver => 'cinder.scheduler.filter_scheduler.FilterScheduler',
  }

  class { '::cinder::setup_test_volume':
    volume_name => 'cinder-volumes',
    size => $volume_size
  } ->

  class { '::cinder::volume': }

  class { '::cinder::volume::rbd':
    rbd_pool => 'volumes',
    rbd_user => 'cinder',
    rbd_secret_uuid => $secret,
  }

  class { '::cinder::backup': }
  class { '::cinder::backup::ceph':
    backup_ceph_user => 'cinder-backup',
  }
#HAproxy setup commented
#  @@haproxy::balancermember { "cinder_api_${::fqdn}":
#    listening_service => 'cinder_api_cluster',
#    server_names => $::hostname,
#    ipaddresses => $::facts["ipaddress_${public_interface}"],
#    ports => '8776',
#    options => 'check inter 2000 rise 2 fall 5',
#  }
}
